org.apache.xerces.impl.xs

## Class XMLSchemaValidatorBase

- java.lang.Object
- - org.apache.xerces.impl.xs.XMLSchemaValidatorBase

- All Implemented Interfaces:
    FieldActivator, XSElementDeclHelper
  Direct Known Subclasses:
    XMLSchemaValidator

      public class XMLSchemaValidatorBase
      extends java.lang.Object
      implements XSElementDeclHelper, FieldActivator

  A class providing certain functionalities and has validation session data for the XML Schema validator. Important functionalities provided by this class are IDC constraint implementation, schema error handling routines and CTA/assertion interfaces with the XML Schema validator.
  Version:
    $Id: XMLSchemaValidatorBase.java 1871904 2019-12-22 06:51:11Z mukulg $
  Author:
    Sandy Gao IBM, Elena Litani IBM, Andy Clark IBM, Neeraj Bajaj, Sun Microsystems, inc., Mukul Gandhi IBM

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `XMLSchemaValidatorBase.KeyRefValueStore` Key reference value store.
    `protected class` | `XMLSchemaValidatorBase.KeyValueStore` Key value store.
    `protected static class` | `XMLSchemaValidatorBase.LocalIDKey`
    `protected static class` | `XMLSchemaValidatorBase.ShortVector` A simple vector for `short`s.
    `protected class` | `XMLSchemaValidatorBase.UniqueValueStore` Unique value store.
    `protected class` | `XMLSchemaValidatorBase.ValueStoreBase` Value store implementation base class.
    `protected class` | `XMLSchemaValidatorBase.ValueStoreCache` Value store cache.
    `protected static class` | `XMLSchemaValidatorBase.XPathMatcherStack` Stack of XPath matchers for identity constraints.
    `protected class` | `XMLSchemaValidatorBase.XSIErrorReporter` A wrapper of the standard error reporter.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static java.lang.String` | `ALLOW_JAVA_ENCODINGS` Feature identifier: whether to recognize java encoding names
    `protected static java.lang.String` | `ASSERT_COMMENT_PI_CHECKING` Feature identifier: whether to allow comment and PI nodes to be visible during processing
    `protected static int` | `BUFFER_SIZE`
    `protected static java.lang.String` | `CONTINUE_AFTER_FATAL_ERROR` Feature identifier: whether to continue parsing a schema after a fatal error is encountered
    `protected static java.lang.String` | `CTA_FULL_XPATH_CHECKING` Feature identifier: whether to allow full XPath 2.0 checking for CTA processing
    `protected static java.lang.String` | `DATATYPE_XML_VERSION` Property identifier: datatype xml version.
    `protected static boolean` | `DEBUG`
    `protected static boolean` | `DEBUG_NORMALIZATION`
    `protected static java.lang.String` | `DYNAMIC_VALIDATION` Feature identifier: dynamic validation.
    `protected static java.util.Hashtable` | `EMPTY_TABLE`
    `protected static java.lang.String` | `ENTITY_MANAGER`
    `static java.lang.String` | `ENTITY_RESOLVER` Property identifier: entity resolver.
    `static java.lang.String` | `ERROR_REPORTER` Property identifier: error reporter.
    `protected boolean` | `fAppendBuffer` Whether need to append characters to fBuffer
    `protected XSDAssertionValidator` | `fAssertionValidator`
    `protected AugmentationsImpl` | `fAugmentations`
    `protected boolean` | `fAugPSVI`
    `protected java.lang.StringBuffer` | `fBuffer` Temporary string buffers.
    `protected CMBuilder` | `fCMBuilder` used to build content models
    `protected XSCMValidator[]` | `fCMStack` Content model stack.
    `protected int[][]` | `fCMStateStack` stack to hold content model states
    `protected boolean` | `fCommentsAndPIsForAssert`
    `protected int[]` | `fCurrCMState` the current state of the current content model
    `protected XSCMValidator` | `fCurrentCM` Current content model.
    `protected XSElementDecl` | `fCurrentElemDecl` Current element declaration.
    `protected ElementPSVImpl` | `fCurrentPSVI` current PSVI element info
    `protected org.apache.xerces.xs.XSTypeDefinition` | `fCurrentType` Current type.
    `protected java.lang.String` | `fDatatypeXMLVersion`
    `protected org.apache.xerces.xni.XMLString` | `fDefaultValue`
    `protected org.apache.xerces.xni.XMLDocumentHandler` | `fDocumentHandler` Document handler.
    `protected org.apache.xerces.xni.parser.XMLDocumentSource` | `fDocumentSource`
    `protected boolean` | `fDoValidation`
    `protected boolean` | `fDynamicValidation`
    `protected static java.lang.Boolean[]` | `FEATURE_DEFAULTS` Feature defaults.
    `protected XSElementDecl[]` | `fElemDeclStack` Element decl stack.
    `protected int` | `fElementDepth` Element depth: -2: validator not in pipeline; >= -1 current depth.
    `protected org.apache.xerces.xni.XMLString` | `fEmptyXMLStr`
    `protected boolean` | `fEntityRef`
    `protected org.apache.xerces.xni.parser.XMLEntityResolver` | `fEntityResolver` Entity resolver
    `protected java.util.Hashtable` | `fExpandedLocationPairs`
    `protected java.lang.String` | `fExternalNoNamespaceSchema`
    `protected java.lang.String` | `fExternalSchemas`
    `protected org.apache.xerces.xs.datatypes.ObjectList` | `fFailedAssertions` Failed assertions.
    `protected boolean` | `fFirstChunk`
    `protected boolean` | `fFullChecking`
    `protected XSGrammarBucket` | `fGrammarBucket` Schema grammar resolver.
    `protected org.apache.xerces.xni.grammars.XMLGrammarPool` | `fGrammarPool`
    `protected boolean` | `fIDCChecking`
    `protected boolean` | `fIdConstraint`
    `protected org.apache.xerces.impl.xs.IDContext` | `fIDContext`
    `protected int` | `fIgnoreXSITypeDepth`
    `protected boolean` | `fInCDATA`
    `protected IntStack` | `fInhrAttrCountStack`
    `protected java.lang.Object` | `fJaxpSchemaSource`
    `protected java.util.Hashtable` | `fLocationPairs`
    `protected org.apache.xerces.xni.XMLLocator` | `fLocator` While parsing a document, keep the location of the document.
    `protected XMLSchemaValidatorBase.XPathMatcherStack` | `fMatcherStack` Stack of active XPath matchers for identity constraints.
    `protected org.apache.xerces.xni.NamespaceContext` | `fNamespaceContext`
    `protected boolean` | `fNamespaceGrowth`
    `protected int` | `fNFullValidationDepth` anything above this level has validation_attempted != full
    `protected boolean` | `fNil` nil value of the current element
    `protected boolean[]` | `fNilStack` nil value stack
    `protected int` | `fNNoneValidationDepth` anything above this level has validation_attempted != none
    `protected boolean` | `fNormalizeData`
    `protected org.apache.xerces.xni.XMLString` | `fNormalizedStr`
    `protected XSNotationDecl` | `fNotation` notation value of the current element
    `protected XSNotationDecl[]` | `fNotationStack` notation stack
    `protected XSSimpleType` | `fQNameDV` the DV usd to convert xsi:type to a QName
    `protected XSElementDecl` | `fRootElementDeclaration`
    `protected javax.xml.namespace.QName` | `fRootElementDeclQName` value of the "root-element-declaration" property.
    `protected org.apache.xerces.xs.XSTypeDefinition` | `fRootTypeDefinition`
    `protected javax.xml.namespace.QName` | `fRootTypeQName` value of the "root-type-definition" property.
    `protected boolean` | `fSawCharacters` Did we see non-whitespace character data?
    `protected boolean` | `fSawText` Did we see any character data?
    `protected boolean[]` | `fSawTextStack` stack to record if we saw character data
    `protected boolean` | `fSchemaDynamicValidation`
    `protected boolean` | `fSchemaElementDefault`
    `protected XMLSchemaLoader` | `fSchemaLoader`
    `protected java.lang.String` | `fSchemaType` Schema type: None, DTD, Schema
    `protected int` | `fSkipValidationDepth` Skip validation: anything below this level should be skipped
    `protected ValidationState` | `fState4ApplyDefault`
    `protected ValidationState` | `fState4XsiType`
    `protected boolean` | `fStrictAssess` whether the curret element is strictly assessed
    `protected boolean[]` | `fStrictAssessStack` strict assess stack
    `protected boolean[]` | `fStringContent` Stack to record if we saw character data outside of element content
    `protected boolean` | `fSubElement` Seen sub elements.
    `protected boolean[]` | `fSubElementStack` Seen sub elements stack.
    `protected SubstitutionGroupHandler` | `fSubGroupHandler`
    `protected SymbolTable` | `fSymbolTable` Symbol table.
    `protected org.apache.xerces.xni.QName` | `fTempQName` temporary qname
    `protected boolean` | `fTrailing`
    `protected org.apache.xerces.xs.XSTypeAlternative` | `fTypeAlternative` Type Alternative augmentation information.
    `protected boolean` | `fTypeAlternativesChecking`
    `protected XSDTypeAlternativeValidator` | `fTypeAlternativeValidator`
    `protected org.apache.xerces.xs.XSTypeDefinition[]` | `fTypeStack` type stack.
    `protected boolean` | `fUnionType`
    `protected java.util.ArrayList` | `fUnparsedLocations`
    `protected boolean` | `fUseGrammarPoolOnly`
    `protected ValidatedInfo` | `fValidatedInfo` temporary validated info
    `protected ValidationManager` | `fValidationManager`
    `protected java.lang.String` | `fValidationRoot` String representation of the validation root.
    `protected org.apache.xerces.impl.xs.XSValidationState` | `fValidationState`
    `protected XMLSchemaValidatorBase.ValueStoreCache` | `fValueStoreCache` Cache of value stores for identity constraint fields.
    `protected short` | `fWhiteSpace`
    `protected XSDDescription` | `fXSDDescription` Schema Grammar Description passed, to give a chance to application to supply the Grammar
    `protected XMLSchemaValidatorBase.XSIErrorReporter` | `fXSIErrorReporter` Error reporter.
    `protected java.util.ArrayList` | `fXSITypeErrors`
    `protected static java.lang.String` | `GENERATE_SYNTHETIC_ANNOTATIONS` Feature: generate synthetic annotations
    `protected static java.lang.String` | `HONOUR_ALL_SCHEMALOCATIONS` Feature identifier: honour all schemaLocations
    `protected static int` | `ID_CONSTRAINT_NUM`
    `protected static java.lang.String` | `ID_IDREF_CHECKING` Feature identifier: whether to ignore ID/IDREF errors
    `protected static java.lang.String` | `IDENTITY_CONSTRAINT_CHECKING` Feature identifier: whether to ignore identity constraint errors
    `protected static java.lang.String` | `IGNORE_XSI_TYPE` Feature identifier: whether to ignore xsi:type attributes until a global element declaration is encountered
    `protected static java.lang.String` | `JAXP_SCHEMA_LANGUAGE` Property identifier: JAXP schema language.
    `protected static java.lang.String` | `JAXP_SCHEMA_SOURCE` Property identifier: JAXP schema source.
    `protected static java.lang.String` | `NAMESPACE_GROWTH` Feature identifier: namespace growth
    `protected CMNodeFactory` | `nodeFactory`
    `protected static java.lang.String` | `NORMALIZE_DATA` Feature identifier: expose schema normalized value
    `protected static java.lang.String` | `PARSER_SETTINGS`
    `protected static java.lang.Object[]` | `PROPERTY_DEFAULTS` Property defaults.
    `protected static java.lang.String[]` | `RECOGNIZED_FEATURES` Recognized features.
    `protected static java.lang.String[]` | `RECOGNIZED_PROPERTIES` Recognized properties.
    `protected static java.lang.String` | `ROOT_ELEMENT_DECL` Property identifier: root element declaration.
    `protected static java.lang.String` | `ROOT_TYPE_DEF` Property identifier: root type definition.
    `protected static java.lang.String` | `SCHEMA_AUGMENT_PSVI` Feature identifier: augment PSVI
    `protected static java.lang.String` | `SCHEMA_DV_FACTORY` Property identifier: Schema DV Factory
    `protected static java.lang.String` | `SCHEMA_ELEMENT_DEFAULT` Feature identifier: send element default value via characters()
    `protected static java.lang.String` | `SCHEMA_FULL_CHECKING` Feature identifier: schema full checking
    `protected static java.lang.String` | `SCHEMA_LOCATION` Property identifier: schema location.
    `protected static java.lang.String` | `SCHEMA_NONS_LOCATION` Property identifier: no namespace schema location.
    `protected static java.lang.String` | `SCHEMA_VALIDATION` Feature identifier: validation.
    `protected static java.lang.String` | `STANDARD_URI_CONFORMANT_FEATURE` Feature identifier: standard uri conformant feature.
    `static java.lang.String` | `SYMBOL_TABLE` Property identifier: symbol table.
    `protected static java.lang.String` | `TOLERATE_DUPLICATES` Feature identifier: tolerate duplicates
    `protected static java.lang.String` | `TYPE_ALTERNATIVES_CHECKING` Feature identifier: whether to ignore type alternatives
    `protected static java.lang.String` | `UNPARSED_ENTITY_CHECKING` Feature identifier: whether to ignore unparsed entity errors
    `protected static java.lang.String` | `USE_GRAMMAR_POOL_ONLY` Feature identifier: use grammar pool only
    `protected static java.lang.String` | `VALIDATE_ANNOTATIONS` Feature identifier: validate annotations.
    `protected static java.lang.String` | `VALIDATION` Feature identifier: validation.
    `protected static java.lang.String` | `VALIDATION_MANAGER`
    `protected static java.lang.String` | `XML_SCHEMA_VERSION` Property identifier: xml schema version.
    `static java.lang.String` | `XMLGRAMMAR_POOL` Property identifier: grammar pool.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `XMLSchemaValidatorBase()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `XPathMatcher` | `activateField(Field field, int initialDepth)` Request to activate the specified field.
    `void` | `endValueScopeFor(IdentityConstraint identityConstraint, int initialDepth)` Ends the value scope for the specified identity constraint.
    `XSElementDecl` | `getGlobalElementDecl(org.apache.xerces.xni.QName element)`
    `void` | `startValueScopeFor(IdentityConstraint identityConstraint, int initialDepth)` Start the value scope for the specified identity constraint.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEBUG

          protected static final boolean DEBUG

      See Also:
        Constant Field Values

    - #### VALIDATION

          protected static final java.lang.String VALIDATION

      Feature identifier: validation.
      See Also:
        Constant Field Values

    - #### SCHEMA_VALIDATION

          protected static final java.lang.String SCHEMA_VALIDATION

      Feature identifier: validation.
      See Also:
        Constant Field Values

    - #### SCHEMA_FULL_CHECKING

          protected static final java.lang.String SCHEMA_FULL_CHECKING

      Feature identifier: schema full checking
      See Also:
        Constant Field Values

    - #### DYNAMIC_VALIDATION

          protected static final java.lang.String DYNAMIC_VALIDATION

      Feature identifier: dynamic validation.
      See Also:
        Constant Field Values

    - #### NORMALIZE_DATA

          protected static final java.lang.String NORMALIZE_DATA

      Feature identifier: expose schema normalized value
      See Also:
        Constant Field Values

    - #### SCHEMA_ELEMENT_DEFAULT

          protected static final java.lang.String SCHEMA_ELEMENT_DEFAULT

      Feature identifier: send element default value via characters()
      See Also:
        Constant Field Values

    - #### SCHEMA_AUGMENT_PSVI

          protected static final java.lang.String SCHEMA_AUGMENT_PSVI

      Feature identifier: augment PSVI
      See Also:
        Constant Field Values

    - #### ALLOW_JAVA_ENCODINGS

          protected static final java.lang.String ALLOW_JAVA_ENCODINGS

      Feature identifier: whether to recognize java encoding names
      See Also:
        Constant Field Values

    - #### STANDARD_URI_CONFORMANT_FEATURE

          protected static final java.lang.String STANDARD_URI_CONFORMANT_FEATURE

      Feature identifier: standard uri conformant feature.
      See Also:
        Constant Field Values

    - #### GENERATE_SYNTHETIC_ANNOTATIONS

          protected static final java.lang.String GENERATE_SYNTHETIC_ANNOTATIONS

      Feature: generate synthetic annotations
      See Also:
        Constant Field Values

    - #### VALIDATE_ANNOTATIONS

          protected static final java.lang.String VALIDATE_ANNOTATIONS

      Feature identifier: validate annotations.
      See Also:
        Constant Field Values

    - #### HONOUR_ALL_SCHEMALOCATIONS

          protected static final java.lang.String HONOUR_ALL_SCHEMALOCATIONS

      Feature identifier: honour all schemaLocations
      See Also:
        Constant Field Values

    - #### USE_GRAMMAR_POOL_ONLY

          protected static final java.lang.String USE_GRAMMAR_POOL_ONLY

      Feature identifier: use grammar pool only
      See Also:
        Constant Field Values

    - #### CONTINUE_AFTER_FATAL_ERROR

          protected static final java.lang.String CONTINUE_AFTER_FATAL_ERROR

      Feature identifier: whether to continue parsing a schema after a fatal error is encountered
      See Also:
        Constant Field Values

    - #### PARSER_SETTINGS

          protected static final java.lang.String PARSER_SETTINGS

      See Also:
        Constant Field Values

    - #### NAMESPACE_GROWTH

          protected static final java.lang.String NAMESPACE_GROWTH

      Feature identifier: namespace growth
      See Also:
        Constant Field Values

    - #### TOLERATE_DUPLICATES

          protected static final java.lang.String TOLERATE_DUPLICATES

      Feature identifier: tolerate duplicates
      See Also:
        Constant Field Values

    - #### IGNORE_XSI_TYPE

          protected static final java.lang.String IGNORE_XSI_TYPE

      Feature identifier: whether to ignore xsi:type attributes until a global element declaration is encountered
      See Also:
        Constant Field Values

    - #### ID_IDREF_CHECKING

          protected static final java.lang.String ID_IDREF_CHECKING

      Feature identifier: whether to ignore ID/IDREF errors
      See Also:
        Constant Field Values

    - #### UNPARSED_ENTITY_CHECKING

          protected static final java.lang.String UNPARSED_ENTITY_CHECKING

      Feature identifier: whether to ignore unparsed entity errors
      See Also:
        Constant Field Values

    - #### IDENTITY_CONSTRAINT_CHECKING

          protected static final java.lang.String IDENTITY_CONSTRAINT_CHECKING

      Feature identifier: whether to ignore identity constraint errors
      See Also:
        Constant Field Values

    - #### TYPE_ALTERNATIVES_CHECKING

          protected static final java.lang.String TYPE_ALTERNATIVES_CHECKING

      Feature identifier: whether to ignore type alternatives
      See Also:
        Constant Field Values

    - #### CTA_FULL_XPATH_CHECKING

          protected static final java.lang.String CTA_FULL_XPATH_CHECKING

      Feature identifier: whether to allow full XPath 2.0 checking for CTA processing
      See Also:
        Constant Field Values

    - #### ASSERT_COMMENT_PI_CHECKING

          protected static final java.lang.String ASSERT_COMMENT_PI_CHECKING

      Feature identifier: whether to allow comment and PI nodes to be visible during processing
      See Also:
        Constant Field Values

    - #### SYMBOL_TABLE

          public static final java.lang.String SYMBOL_TABLE

      Property identifier: symbol table.
      See Also:
        Constant Field Values

    - #### ERROR_REPORTER

          public static final java.lang.String ERROR_REPORTER

      Property identifier: error reporter.
      See Also:
        Constant Field Values

    - #### ENTITY_RESOLVER

          public static final java.lang.String ENTITY_RESOLVER

      Property identifier: entity resolver.
      See Also:
        Constant Field Values

    - #### XMLGRAMMAR_POOL

          public static final java.lang.String XMLGRAMMAR_POOL

      Property identifier: grammar pool.
      See Also:
        Constant Field Values

    - #### VALIDATION_MANAGER

          protected static final java.lang.String VALIDATION_MANAGER

      See Also:
        Constant Field Values

    - #### ENTITY_MANAGER

          protected static final java.lang.String ENTITY_MANAGER

      See Also:
        Constant Field Values

    - #### SCHEMA_LOCATION

          protected static final java.lang.String SCHEMA_LOCATION

      Property identifier: schema location.
      See Also:
        Constant Field Values

    - #### SCHEMA_NONS_LOCATION

          protected static final java.lang.String SCHEMA_NONS_LOCATION

      Property identifier: no namespace schema location.
      See Also:
        Constant Field Values

    - #### JAXP_SCHEMA_SOURCE

          protected static final java.lang.String JAXP_SCHEMA_SOURCE

      Property identifier: JAXP schema source.
      See Also:
        Constant Field Values

    - #### JAXP_SCHEMA_LANGUAGE

          protected static final java.lang.String JAXP_SCHEMA_LANGUAGE

      Property identifier: JAXP schema language.
      See Also:
        Constant Field Values

    - #### ROOT_TYPE_DEF

          protected static final java.lang.String ROOT_TYPE_DEF

      Property identifier: root type definition.
      See Also:
        Constant Field Values

    - #### ROOT_ELEMENT_DECL

          protected static final java.lang.String ROOT_ELEMENT_DECL

      Property identifier: root element declaration.
      See Also:
        Constant Field Values

    - #### SCHEMA_DV_FACTORY

          protected static final java.lang.String SCHEMA_DV_FACTORY

      Property identifier: Schema DV Factory
      See Also:
        Constant Field Values

    - #### XML_SCHEMA_VERSION

          protected static final java.lang.String XML_SCHEMA_VERSION

      Property identifier: xml schema version.
      See Also:
        Constant Field Values

    - #### DATATYPE_XML_VERSION

          protected static final java.lang.String DATATYPE_XML_VERSION

      Property identifier: datatype xml version.
      See Also:
        Constant Field Values

    - #### RECOGNIZED_FEATURES

          protected static final java.lang.String[] RECOGNIZED_FEATURES

      Recognized features.

    - #### FEATURE_DEFAULTS

          protected static final java.lang.Boolean[] FEATURE_DEFAULTS

      Feature defaults.

    - #### RECOGNIZED_PROPERTIES

          protected static final java.lang.String[] RECOGNIZED_PROPERTIES

      Recognized properties.

    - #### PROPERTY_DEFAULTS

          protected static final java.lang.Object[] PROPERTY_DEFAULTS

      Property defaults.

    - #### ID_CONSTRAINT_NUM

          protected static final int ID_CONSTRAINT_NUM

      See Also:
        Constant Field Values

    - #### EMPTY_TABLE

          protected static final java.util.Hashtable EMPTY_TABLE

    - #### fCurrentPSVI

          protected ElementPSVImpl fCurrentPSVI

      current PSVI element info

    - #### fAugmentations

          protected final AugmentationsImpl fAugmentations

    - #### fDefaultValue

          protected org.apache.xerces.xni.XMLString fDefaultValue

    - #### fDynamicValidation

          protected boolean fDynamicValidation

    - #### fSchemaDynamicValidation

          protected boolean fSchemaDynamicValidation

    - #### fDoValidation

          protected boolean fDoValidation

    - #### fFullChecking

          protected boolean fFullChecking

    - #### fNormalizeData

          protected boolean fNormalizeData

    - #### fSchemaElementDefault

          protected boolean fSchemaElementDefault

    - #### fAugPSVI

          protected boolean fAugPSVI

    - #### fIdConstraint

          protected boolean fIdConstraint

    - #### fUseGrammarPoolOnly

          protected boolean fUseGrammarPoolOnly

    - #### fNamespaceGrowth

          protected boolean fNamespaceGrowth

    - #### fSchemaType

          protected java.lang.String fSchemaType

      Schema type: None, DTD, Schema

    - #### fEntityRef

          protected boolean fEntityRef

    - #### fInCDATA

          protected boolean fInCDATA

    - #### fSymbolTable

          protected SymbolTable fSymbolTable

      Symbol table.

    - #### fLocator

          protected org.apache.xerces.xni.XMLLocator fLocator

      While parsing a document, keep the location of the document.

    - #### fXSITypeErrors

          protected java.util.ArrayList fXSITypeErrors

    - #### fIDContext

          protected org.apache.xerces.impl.xs.IDContext fIDContext

    - #### fDatatypeXMLVersion

          protected java.lang.String fDatatypeXMLVersion

    - #### fNamespaceContext

          protected org.apache.xerces.xni.NamespaceContext fNamespaceContext

    - #### fXSIErrorReporter

          protected final XMLSchemaValidatorBase.XSIErrorReporter fXSIErrorReporter

      Error reporter.

    - #### fEntityResolver

          protected org.apache.xerces.xni.parser.XMLEntityResolver fEntityResolver

      Entity resolver

    - #### fValidationManager

          protected ValidationManager fValidationManager

    - #### fValidationState

          protected org.apache.xerces.impl.xs.XSValidationState fValidationState

    - #### fGrammarPool

          protected org.apache.xerces.xni.grammars.XMLGrammarPool fGrammarPool

    - #### fExternalSchemas

          protected java.lang.String fExternalSchemas

    - #### fExternalNoNamespaceSchema

          protected java.lang.String fExternalNoNamespaceSchema

    - #### fJaxpSchemaSource

          protected java.lang.Object fJaxpSchemaSource

    - #### fXSDDescription

          protected final XSDDescription fXSDDescription

      Schema Grammar Description passed, to give a chance to application to supply the Grammar

    - #### fLocationPairs

          protected final java.util.Hashtable fLocationPairs

    - #### fExpandedLocationPairs

          protected final java.util.Hashtable fExpandedLocationPairs

    - #### fUnparsedLocations

          protected final java.util.ArrayList fUnparsedLocations

    - #### fDocumentHandler

          protected org.apache.xerces.xni.XMLDocumentHandler fDocumentHandler

      Document handler.

    - #### fDocumentSource

          protected org.apache.xerces.xni.parser.XMLDocumentSource fDocumentSource

    - #### DEBUG_NORMALIZATION

          protected static final boolean DEBUG_NORMALIZATION

      See Also:
        Constant Field Values

    - #### fEmptyXMLStr

          protected final org.apache.xerces.xni.XMLString fEmptyXMLStr

    - #### BUFFER_SIZE

          protected static final int BUFFER_SIZE

      See Also:
        Constant Field Values

    - #### fNormalizedStr

          protected final org.apache.xerces.xni.XMLString fNormalizedStr

    - #### fFirstChunk

          protected boolean fFirstChunk

    - #### fTrailing

          protected boolean fTrailing

    - #### fWhiteSpace

          protected short fWhiteSpace

    - #### fUnionType

          protected boolean fUnionType

    - #### fGrammarBucket

          protected final XSGrammarBucket fGrammarBucket

      Schema grammar resolver.

    - #### fSubGroupHandler

          protected final SubstitutionGroupHandler fSubGroupHandler

    - #### fQNameDV

          protected final XSSimpleType fQNameDV

      the DV usd to convert xsi:type to a QName

    - #### nodeFactory

          protected final CMNodeFactory nodeFactory

    - #### fCMBuilder

          protected final CMBuilder fCMBuilder

      used to build content models

    - #### fSchemaLoader

          protected final XMLSchemaLoader fSchemaLoader

    - #### fValidationRoot

          protected java.lang.String fValidationRoot

      String representation of the validation root.

    - #### fSkipValidationDepth

          protected int fSkipValidationDepth

      Skip validation: anything below this level should be skipped

    - #### fNFullValidationDepth

          protected int fNFullValidationDepth

      anything above this level has validation_attempted != full

    - #### fNNoneValidationDepth

          protected int fNNoneValidationDepth

      anything above this level has validation_attempted != none

    - #### fElementDepth

          protected int fElementDepth

      Element depth: -2: validator not in pipeline; >= -1 current depth.

    - #### fSubElement

          protected boolean fSubElement

      Seen sub elements.

    - #### fSubElementStack

          protected boolean[] fSubElementStack

      Seen sub elements stack.

    - #### fCurrentElemDecl

          protected XSElementDecl fCurrentElemDecl

      Current element declaration.

    - #### fElemDeclStack

          protected XSElementDecl[] fElemDeclStack

      Element decl stack.

    - #### fNil

          protected boolean fNil

      nil value of the current element

    - #### fNilStack

          protected boolean[] fNilStack

      nil value stack

    - #### fNotation

          protected XSNotationDecl fNotation

      notation value of the current element

    - #### fNotationStack

          protected XSNotationDecl[] fNotationStack

      notation stack

    - #### fCurrentType

          protected org.apache.xerces.xs.XSTypeDefinition fCurrentType

      Current type.

    - #### fFailedAssertions

          protected org.apache.xerces.xs.datatypes.ObjectList fFailedAssertions

      Failed assertions.

    - #### fTypeAlternative

          protected org.apache.xerces.xs.XSTypeAlternative fTypeAlternative

      Type Alternative augmentation information.

    - #### fTypeStack

          protected org.apache.xerces.xs.XSTypeDefinition[] fTypeStack

      type stack.

    - #### fCurrentCM

          protected XSCMValidator fCurrentCM

      Current content model.

    - #### fCMStack

          protected XSCMValidator[] fCMStack

      Content model stack.

    - #### fCurrCMState

          protected int[] fCurrCMState

      the current state of the current content model

    - #### fCMStateStack

          protected int[][] fCMStateStack

      stack to hold content model states

    - #### fStrictAssess

          protected boolean fStrictAssess

      whether the curret element is strictly assessed

    - #### fStrictAssessStack

          protected boolean[] fStrictAssessStack

      strict assess stack

    - #### fBuffer

          protected final java.lang.StringBuffer fBuffer

      Temporary string buffers.

    - #### fAppendBuffer

          protected boolean fAppendBuffer

      Whether need to append characters to fBuffer

    - #### fSawText

          protected boolean fSawText

      Did we see any character data?

    - #### fSawTextStack

          protected boolean[] fSawTextStack

      stack to record if we saw character data

    - #### fSawCharacters

          protected boolean fSawCharacters

      Did we see non-whitespace character data?

    - #### fStringContent

          protected boolean[] fStringContent

      Stack to record if we saw character data outside of element content

    - #### fTempQName

          protected final org.apache.xerces.xni.QName fTempQName

      temporary qname

    - #### fRootTypeQName

          protected javax.xml.namespace.QName fRootTypeQName

      value of the "root-type-definition" property.

    - #### fRootTypeDefinition

          protected org.apache.xerces.xs.XSTypeDefinition fRootTypeDefinition

    - #### fRootElementDeclQName

          protected javax.xml.namespace.QName fRootElementDeclQName

      value of the "root-element-declaration" property.

    - #### fRootElementDeclaration

          protected XSElementDecl fRootElementDeclaration

    - #### fIgnoreXSITypeDepth

          protected int fIgnoreXSITypeDepth

    - #### fIDCChecking

          protected boolean fIDCChecking

    - #### fTypeAlternativesChecking

          protected boolean fTypeAlternativesChecking

    - #### fCommentsAndPIsForAssert

          protected boolean fCommentsAndPIsForAssert

    - #### fValidatedInfo

          protected ValidatedInfo fValidatedInfo

      temporary validated info

    - #### fState4XsiType

          protected ValidationState fState4XsiType

    - #### fState4ApplyDefault

          protected ValidationState fState4ApplyDefault

    - #### fMatcherStack

          protected XMLSchemaValidatorBase.XPathMatcherStack fMatcherStack

      Stack of active XPath matchers for identity constraints. All active XPath matchers are notified of startElement and endElement callbacks in order to perform their matches.

      For each element with identity constraints, the selector of each identity constraint is activated. When the selector matches its XPath, then all the fields of the identity constraint are activated.

      Note: Once the activation scope is left, the XPath matchers are automatically removed from the stack of active matchers and no longer receive callbacks.

    - #### fValueStoreCache

          protected XMLSchemaValidatorBase.ValueStoreCache fValueStoreCache

      Cache of value stores for identity constraint fields.

    - #### fAssertionValidator

          protected XSDAssertionValidator fAssertionValidator

    - #### fTypeAlternativeValidator

          protected XSDTypeAlternativeValidator fTypeAlternativeValidator

    - #### fInhrAttrCountStack

          protected IntStack fInhrAttrCountStack

  - ### Constructor Detail

    - #### XMLSchemaValidatorBase

          protected XMLSchemaValidatorBase()

  - ### Method Detail

    - #### getGlobalElementDecl

          public XSElementDecl getGlobalElementDecl(org.apache.xerces.xni.QName element)

      Specified by:
        `getGlobalElementDecl` in interface `XSElementDeclHelper`

    - #### activateField

          public XPathMatcher activateField(Field field,
                                   int initialDepth)

      Request to activate the specified field. This method returns the matcher for the field.
      Specified by:
        `activateField` in interface `FieldActivator`
      Parameters:
        `field` - The field to activate.
        `initialDepth` - the 0-indexed depth in the instance document at which the Selector began to match.

    - #### startValueScopeFor

          public void startValueScopeFor(IdentityConstraint identityConstraint,
                                int initialDepth)

      Start the value scope for the specified identity constraint. This method is called when the selector matches in order to initialize the value store.
      Specified by:
        `startValueScopeFor` in interface `FieldActivator`
      Parameters:
        `identityConstraint` - The identity constraint.
        `initialDepth` - the depth at which the selector began matching

    - #### endValueScopeFor

          public void endValueScopeFor(IdentityConstraint identityConstraint,
                              int initialDepth)

      Ends the value scope for the specified identity constraint.
      Specified by:
        `endValueScopeFor` in interface `FieldActivator`
      Parameters:
        `identityConstraint` - The identity constraint.
        `initialDepth` - the 0-indexed depth where the Selector began to match.

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.